Summary: Apcupsd can be used for controlling APC UPSes.
Name: apcupsd
Version: 3.8.5
Release: 1.0.1
Copyright: GPL
Group: System Environment/Daemons
Source: http://unc.dl.sourceforge.net/sourceforge/apcupsd/apcupsd-3.8.5.tar.gz
URL: http://www.sibbald.com/apcupsd/
BuildRoot: %{_tmppath}/%name-root
Vendor: Guardian Digital Inc.
Distribution: EnGarde Secure Linux
Packager: Eric Lubow <eric@guardiandigital.com>

%description 
  Apcupsd can be used for controlling APC UPSes. During a power
  failure, apcupsd will inform the users about the power failure
  and that a shutdown may occur. If power is not restored, a system
  shutdown will follow when the battery is exhausted, a timeout
  (seconds) expires, or runtime expires based on internal APC
  calculations determined by power consumption rates. If the power
  is restored before one of the above shutdown conditions is met,
  apcupsd will inform users about this fact. 


%prep
%setup -q

%build
./configure \
  --prefix=/usr \
  --sbindir=/sbin \
  --with-libwrap \
  --with-cgi-bin=/home/httpd/cgi-bin \
  --enable-cgi \
  --with-css-dir=/home/httpd/html \
  --with-log-dir=/var/log/apcupsd \
  --with-pid-dir=/var/run \
  --with-lock-dir=/var/lock/subsys \
  --enable-pthreads \
  --enable-powerflute

make CFLAGS="$RPM_OPT_FLAGS -O2 -Wall"

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT
# Make directories where we install things
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
mkdir -p $RPM_BUILD_ROOT/home/httpd/cgi-bin
mkdir -p $RPM_BUILD_ROOT/var/log/apcupsd
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/etc/apcupsd

install -m700 $RPM_BUILD_DIR/%{name}-%{version}/apcupsd $RPM_BUILD_ROOT/sbin
install -m700 $RPM_BUILD_DIR/%{name}-%{version}/apcnisd $RPM_BUILD_ROOT/sbin
install -m700 $RPM_BUILD_DIR/%{name}-%{version}/apcaccess $RPM_BUILD_ROOT/sbin

install -m700 $RPM_BUILD_DIR/%{name}-%{version}/distributions/engarde/apccontrol.sh $RPM_BUILD_ROOT/etc/apcupsd/apccontrol
install -m644 $RPM_BUILD_DIR/%{name}-%{version}/etc/apcupsd.conf $RPM_BUILD_ROOT/etc/apcupsd

install -m644 $RPM_BUILD_DIR/%{name}-%{version}/doc/apcupsd.man $RPM_BUILD_ROOT/usr/share/man/man8/apcupsd.8

install -m700 $RPM_BUILD_DIR/%{name}-%{version}/distributions/engarde/apcupsd $RPM_BUILD_ROOT/etc/init.d

# make sure examples directory is included with doc files
cp -rp $RPM_BUILD_DIR/%{name}-%{version}/examples $RPM_BUILD_DIR/%{name}-%{version}/doc/

cp -p $RPM_BUILD_DIR/%{name}-%{version}/cgi/*.cgi $RPM_BUILD_ROOT/home/httpd/cgi-bin
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/hosts.conf $RPM_BUILD_ROOT/etc/apcupsd
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/multimon.conf $RPM_BUILD_ROOT/etc/apcupsd

install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/changeme $RPM_BUILD_ROOT/etc/apcupsd
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/commfailure $RPM_BUILD_ROOT/etc/apcupsd
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/commok $RPM_BUILD_ROOT/etc/apcupsd
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/onbattery $RPM_BUILD_ROOT/etc/apcupsd
install -m750 $RPM_BUILD_DIR/%{name}-%{version}/etc/mainsback $RPM_BUILD_ROOT/etc/apcupsd

strip $RPM_BUILD_ROOT/sbin/*


%post
# delete then add our links
/sbin/chkconfig --del apcupsd
/sbin/chkconfig --add apcupsd

echo "Modifying your halt script"
cp -f /etc/init.d/halt /etc/init.d/halt.old
awk '# Stuff left over from a previous apcupsd, remove it
/^# See if this is a powerfail situation\./ {
   do {
      getline
   }  while (length($0) != 0)
   getline
}
# We insert the new apcupsd code just before the following line
/^### Now halt or reboot\./ {
    print "# See if this is a powerfail situation.                               # ***apcupsd***"
    print "if [ -f /etc/apcupsd/powerfail ]; then                                # ***apcupsd***"
    print "   echo                                                               # ***apcupsd***"
    print "   echo \"APCUPSD will now power off the UPS\"                          # ***apcupsd***"
    print "   echo                                                               # ***apcupsd***"
    print "   /etc/apcupsd/apccontrol killpower                                  # ***apcupsd***"
    print "   echo                                                               # ***apcupsd***"
    print "   echo \"Please ensure that the UPS has powered off before rebooting\" # ***apcupsd***"
    print "   echo \"Otherwise, the UPS may cut the power during the reboot!!!\"   # ***apcupsd***"
    print "   echo                                                               # ***apcupsd***"
    print "   sleep 2                                                            # ***apcupsd***"
    print "   exit 0                                                             # ***apcupsd***"
    print "fi                                                                    # ***apcupsd***"
    print ""
}
# Everything else is duplicated 
{ print } ' /etc/init.d/halt.old > /etc/init.d/halt

chmod 744 /etc/init.d/halt


%preun
# stop running version (if any)                  
# I have removed the following because it sometimes produces
# an error message which may confuse someone.
/etc/init.d/apcupsd stop

# remove startup links
/sbin/chkconfig --del apcupsd

# restore old halt script (hopefully)
#   mv -f /etc/init.d/halt.old /etc/init.d/halt

cp -f /etc/init.d/halt /etc/init.d/halt.old
awk '# Stuff added by apcupsd, remove it
/^# See if this is a powerfail situation\./ {
   do {
      getline
   }  while (length($0) != 0)
   getline
}
# Everything else is duplicated 
{ print } ' /etc/init.d/halt.old > /etc/init.d/halt

chmod 744 /etc/init.d/halt


%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%files
%defattr(-,root,root)
/sbin
%attr(-,root,man) /usr/share/man/man8
/etc/init.d/apcupsd
%attr(640,root,admin) /etc/apcupsd/apccontrol
%attr(640,root,admin) /etc/apcupsd/changeme
%attr(640,root,admin) /etc/apcupsd/commfailure
%attr(640,root,admin) /etc/apcupsd/commok
%attr(640,root,admin) /etc/apcupsd/onbattery
%attr(640,root,admin) /etc/apcupsd/mainsback
%defattr(-,root,root)
%config /etc/apcupsd/apcupsd.conf
%config /etc/apcupsd/hosts.conf
%config /etc/apcupsd/multimon.conf

%doc COPYING ChangeLog INSTALL TODO doc/*


%changelog
* Thu Jan 16 2003 Eric B. Lubow <eric@guardiandigital.com>
- Version 3.8.5, Release 1.0.1 Initial RPM for EnGarde
   + Used the Red Hat 7.0 RPM as base
